Index: /pythonadapter/src/main/java/geniusweb/pythonadapter/PythonPartyAdapter.java
===================================================================
--- /pythonadapter/src/main/java/geniusweb/pythonadapter/PythonPartyAdapter.java	(revision 53)
+++ /pythonadapter/src/main/java/geniusweb/pythonadapter/PythonPartyAdapter.java	(revision 1)
@@ -7,9 +7,9 @@
 
 import geniusweb.actions.Action;
-import geniusweb.connection.ConnectionEnd;
-import geniusweb.inform.Inform;
+import geniusweb.connection.Connection;
 import geniusweb.party.Capabilities;
 import geniusweb.party.DefaultParty;
 import geniusweb.party.Party;
+import geniusweb.party.inform.Inform;
 import tudelft.utilities.listener.Listener;
 
@@ -19,5 +19,5 @@
  * this adapter is needed is that you can not directly use the .py file in java,
  * we have to load a python interpreter and connect it to your file. *
- * <h2>Usage</h2>
+ * <h1>Usage</h1>
  * 
  * <ul>
@@ -36,5 +36,6 @@
  * </ul>
  * 
- * <h2>Working principle</h2>
+ * <p>
+ * <h1>Working principle</h1>
  * 
  * The created jar file contains a full python interpreter plus some glue code.
@@ -103,5 +104,5 @@
 
 	@Override
-	public void connect(ConnectionEnd<Inform, Action> connection) {
+	public void connect(Connection<Inform, Action> connection) {
 		pyparty.connect(connection);
 	}
Index: /references/src/main/java/geniusweb/connection/Connectable.java
===================================================================
--- /references/src/main/java/geniusweb/connection/Connectable.java	(revision 53)
+++ /references/src/main/java/geniusweb/connection/Connectable.java	(revision 1)
@@ -2,8 +2,7 @@
 
 /**
- * A Connectable is an object that can connect on request with a provided
- * {@link ConnectionEnd} and then respond to incoming and outgong signals.
+ * a socket for a general two-way connection
  *
- * @param <INTYPE>  the type of incoming messages
+ * @param <INTYPE> the type of incoming messages
  * @param <OUTTYPE> the type of outgoing messages
  */
@@ -14,5 +13,5 @@
 	 * @param connection the new connection
 	 */
-	void connect(ConnectionEnd<INTYPE, OUTTYPE> connection);
+	void connect(Connection<INTYPE, OUTTYPE> connection);
 
 	/**
Index: /references/src/main/java/geniusweb/connection/Connection.java
===================================================================
--- /references/src/main/java/geniusweb/connection/Connection.java	(revision 1)
+++ /references/src/main/java/geniusweb/connection/Connection.java	(revision 1)
@@ -0,0 +1,65 @@
+package geniusweb.connection;
+
+import java.io.IOException;
+import java.net.SocketException;
+import java.net.URI;
+
+import geniusweb.references.Reference;
+import tudelft.utilities.listener.Listenable;
+
+/**
+ * A general two-way connection. incoming data is reported through the
+ * {@link Listenable} channel, sending events of the INTYPE.
+ * <p>
+ * If an internal error occurs, eg a socket failure, timeout, or parser error, a
+ * null event is sent into the Listenable and {@link #getError()} can be called
+ * to find out about the error.
+ *
+ * @param <INTYPE>  the type of incoming messages. Incoming messages are
+ *                  received through Listener#not. Incoming messages are usually
+ *                  asynchronous.
+ * @param <OUTTYPE> the type of outgoing messages. Outgoing messages can be sent
+ *                  directly with #send.
+ * 
+ */
+public interface Connection<INTYPE, OUTTYPE> extends Listenable<INTYPE> {
+
+	/**
+	 * Send data out (and flush the output so that there are no excessive delays
+	 * in sending the data). This call is assumed to return immediately (never
+	 * block, eg on synchronized, Thread.sleep, IO, etc). When this is called
+	 * multiple times in sequence, the data should arrive at the receiver end in
+	 * the same order.
+	 * 
+	 * @param data the data to be sent.
+	 * @throws IOException if the data failed to be sent.
+	 */
+	void send(OUTTYPE data) throws IOException;
+
+	/**
+	 * @return Reference that was used to create this connection
+	 */
+	Reference getReference();
+
+	/**
+	 * @return the URI of the remote endpoint that makes up the connection. This
+	 *         is a URI that uniquely identifies the remote object
+	 */
+	URI getRemoteURI();
+
+	/**
+	 * Close the connection. Should return immediately (not block). Before
+	 * really closing, this should attempt to send out possibly cached messages
+	 * before closing the connection.
+	 * 
+	 */
+	void close();
+
+	/**
+	 * @return the latest internal error, or null if no error occured. If the
+	 *         channel is closed, this is set to {@link SocketException} "Socket
+	 *         closed", even if the close was a "normal" termination eg when
+	 *         {@link #close()} was called.
+	 */
+	Throwable getError();
+}
Index: /references/src/main/java/geniusweb/connection/ConnectionFactory.java
===================================================================
--- /references/src/main/java/geniusweb/connection/ConnectionFactory.java	(revision 53)
+++ /references/src/main/java/geniusweb/connection/ConnectionFactory.java	(revision 1)
@@ -9,5 +9,4 @@
  * factory that can turn a {@link Reference} into a connection to that
  * reference.
- * 
  * 
  * @param <INTYPE>  the type of incoming messages. Incoming messages are
@@ -31,5 +30,5 @@
 	 *                                 the server. This suggest to retry later.
 	 */
-	ConnectionEnd<INTYPE, OUTTYPE> connect(Reference reference)
+	Connection<INTYPE, OUTTYPE> connect(Reference reference)
 			throws IOException, NoResourcesNowException;
 
Index: /references/src/main/java/geniusweb/connection/DefaultConnection.java
===================================================================
--- /references/src/main/java/geniusweb/connection/DefaultConnection.java	(revision 53)
+++ /references/src/main/java/geniusweb/connection/DefaultConnection.java	(revision 1)
@@ -6,12 +6,12 @@
  * Default implementation of connection. Connection implementors only need to
  * implement the send (which moves the data sent into the connection to the
- * other side) and they can call
- * {@link DefaultListenable#notifyListeners(Object)} to inform the users of the
- * connection that something came in from the other side.
+ * other side) and they can call {@link DefaultListenable#notifyChange(Object)}
+ * to inform the users of the connection that something came in from the other
+ * side.
  *
- * @param <INTYPE>  the datatype of objects received from the other side
+ * @param <INTYPE> the datatype of objects received from the other side
  * @param <OUTTYPE> the datatype of objects sent to the other side.
  */
 public abstract class DefaultConnection<INTYPE, OUTTYPE> extends
-		DefaultListenable<INTYPE> implements ConnectionEnd<INTYPE, OUTTYPE> {
+		DefaultListenable<INTYPE> implements Connection<INTYPE, OUTTYPE> {
 }
Index: /references/src/main/java/geniusweb/references/PartyWithProfile.java
===================================================================
--- /references/src/main/java/geniusweb/references/PartyWithProfile.java	(revision 53)
+++ /references/src/main/java/geniusweb/references/PartyWithProfile.java	(revision 1)
@@ -8,9 +8,9 @@
 @JsonAutoDetect(fieldVisibility = Visibility.ANY, getterVisibility = Visibility.NONE, setterVisibility = Visibility.NONE)
 public class PartyWithProfile {
-	private final PartyWithParameters party;
+	private final PartyRef party;
 	private final ProfileRef profile;
 
 	@JsonCreator
-	public PartyWithProfile(@JsonProperty("party") PartyWithParameters party,
+	public PartyWithProfile(@JsonProperty("party") PartyRef party,
 			@JsonProperty("profile") ProfileRef profile) {
 		if (party == null || profile == null) {
@@ -22,16 +22,9 @@
 	}
 
-	/**
-	 * 
-	 * @return the {@link PartyWithParameters}. never null.
-	 */
-	public PartyWithParameters getParty() {
+	public PartyRef getParty() {
 		return party;
 
 	}
 
-	/**
-	 * @return the profile setting for this party. Never null.
-	 */
 	public ProfileRef getProfile() {
 		return profile;
Index: /references/src/test/java/geniusweb/references/PartyWithProfileTest.java
===================================================================
--- /references/src/test/java/geniusweb/references/PartyWithProfileTest.java	(revision 53)
+++ /references/src/test/java/geniusweb/references/PartyWithProfileTest.java	(revision 1)
@@ -17,4 +17,7 @@
 import com.fasterxml.jackson.databind.ObjectMapper;
 
+import geniusweb.references.PartyRef;
+import geniusweb.references.PartyWithProfile;
+import geniusweb.references.ProfileRef;
 import tudelft.utilities.junit.GeneralTests;
 
@@ -23,7 +26,6 @@
 	private PartyRef party1, party1a, party2, party3;
 	private ProfileRef profile1, profile2;
-	private PartyWithProfile partyprof1, partyprof1a, partyprof2, partyprof3,
-			partyprof4;
-	private final String serialized = "{\"party\":{\"partyref\":\"ws:party1\",\"parameters\":{}},\"profile\":\"ws:profile1\"}";
+	private PartyWithProfile partyprof1, partyprof1a, partyprof2, partyprof3;
+	private final String serialized = "{\"party\":\"ws:party1\",\"profile\":\"ws:profile1\"}";
 
 	@Before
@@ -37,19 +39,8 @@
 		profile2 = new ProfileRef(new URI("ws:profile2"));
 
-		Parameters settings1 = new Parameters();
-		Parameters settings2 = new Parameters().with("a", 1);
-
-		PartyWithParameters party1withparams1 = new PartyWithParameters(party1,
-				settings1);
-		PartyWithParameters party1withparams2 = new PartyWithParameters(party1,
-				settings2);
-		PartyWithParameters party2withparams1 = new PartyWithParameters(party2,
-				settings1);
-
-		partyprof1 = new PartyWithProfile(party1withparams1, profile1);
-		partyprof1a = new PartyWithProfile(party1withparams1, profile1);
-		partyprof2 = new PartyWithProfile(party2withparams1, profile1);
-		partyprof3 = new PartyWithProfile(party1withparams1, profile2);
-		partyprof4 = new PartyWithProfile(party1withparams2, profile1);
+		partyprof1 = new PartyWithProfile(party1, profile1);
+		partyprof1a = new PartyWithProfile(party1, profile1);
+		partyprof2 = new PartyWithProfile(party2, profile1);
+		partyprof3 = new PartyWithProfile(party1, profile2);
 
 	}
@@ -58,6 +49,5 @@
 	public List<List<PartyWithProfile>> getGeneralTestData() {
 		return Arrays.asList(Arrays.asList(partyprof1, partyprof1a),
-				Arrays.asList(partyprof2), Arrays.asList(partyprof3),
-				Arrays.asList(partyprof4));
+				Arrays.asList(partyprof2), Arrays.asList(partyprof3));
 	}
 
@@ -65,8 +55,7 @@
 	public List<String> getGeneralTestStrings() {
 		return Arrays.asList(
-				"PartyWithProfile.PartyRef.ws:party1.,ProfileRef.ws:profile1.*",
-				"PartyWithProfile.PartyRef.ws:party2.,ProfileRef.ws:profile1.*",
-				"PartyWithProfile.PartyRef.ws:party1.,ProfileRef.ws:profile2.*",
-				"PartyWithProfile.PartyRef.ws:party1.\\{a=1\\},ProfileRef.ws:profile1.*");
+				"PartyWithProfile.PartyRef.ws:party1.,ProfileRef.ws:profile1..",
+				"PartyWithProfile.PartyRef.ws:party2.,ProfileRef.ws:profile1..",
+				"PartyWithProfile.PartyRef.ws:party1.,ProfileRef.ws:profile2..");
 	}
 
@@ -77,5 +66,5 @@
 	@Test(expected = IllegalArgumentException.class)
 	public void nullTest() throws URISyntaxException {
-		new PartyWithProfile((PartyWithParameters) null, (ProfileRef) null);
+		new PartyWithProfile((PartyRef) null, (ProfileRef) null);
 	}
 
Index: /references/src/test/java/geniusweb/references/ProtocolRefTest.java
===================================================================
--- /references/src/test/java/geniusweb/references/ProtocolRefTest.java	(revision 53)
+++ /references/src/test/java/geniusweb/references/ProtocolRefTest.java	(revision 1)
@@ -17,4 +17,5 @@
 import com.fasterxml.jackson.databind.ObjectMapper;
 
+import geniusweb.references.ProtocolRef;
 import tudelft.utilities.junit.GeneralTests;
 
@@ -57,11 +58,4 @@
 
 	@Test
-	public void testSaop() {
-		ProtocolRef saop = new ProtocolRef("SAOP");
-		System.out.println(saop.getURI());
-		assertEquals("SAOP", saop.getURI().getPath());
-	}
-
-	@Test
 	public void testSerialize() throws JsonProcessingException {
 		ObjectMapper jackson = new ObjectMapper();
Index: /simplerunner/src/main/java/geniusweb/simplerunner/BasicConnection.java
===================================================================
--- /simplerunner/src/main/java/geniusweb/simplerunner/BasicConnection.java	(revision 53)
+++ /simplerunner/src/main/java/geniusweb/simplerunner/BasicConnection.java	(revision 1)
@@ -3,10 +3,8 @@
 import java.io.IOException;
 import java.net.URI;
-import java.util.List;
-import java.util.concurrent.ArrayBlockingQueue;
-import java.util.concurrent.CopyOnWriteArrayList;
 
-import geniusweb.connection.ConnectionEnd;
+import geniusweb.connection.Connection;
 import geniusweb.references.Reference;
+import tudelft.utilities.listener.DefaultListenable;
 import tudelft.utilities.listener.Listener;
 
@@ -18,15 +16,10 @@
  * @param <OUT> the type of outgoing data
  */
-public class BasicConnection<IN, OUT> implements ConnectionEnd<IN, OUT> {
-	private List<Listener<IN>> listeners = new CopyOnWriteArrayList<Listener<IN>>();
-
-	private final Info<OUT> EOS = new EOS<OUT>();
+public class BasicConnection<IN, OUT> extends DefaultListenable<IN>
+		implements Connection<IN, OUT> {
 	private final Reference reference;
 	private final URI uri;
 	// to be initialized
 	private Listener<OUT> handler = null;
-	private ArrayBlockingQueue<Info<OUT>> messages = new ArrayBlockingQueue<>(
-			4);
-	private Throwable error;
 
 	/**
@@ -46,5 +39,5 @@
 	 * from us. Must be called first.
 	 * 
-	 * @param newhandler a Listener&lt;OUT&gt; that can handle send actions.
+	 * @param handler a Listener<OUT> that can handle send actions.
 	 * 
 	 */
@@ -54,38 +47,4 @@
 		}
 		this.handler = newhandler;
-
-		Thread handlerThread = new Thread(new Runnable() {
-
-			@Override
-			public void run() {
-				try {
-					while (true) {
-						Info<OUT> mess = messages.take();
-						if (mess instanceof EOS)
-							break;
-						handler.notifyChange(((Data<OUT>) mess).get());
-					}
-				} catch (Exception e) {
-					setError(e);
-				}
-				handler = null;
-				System.out.println("BasicConnection closed");
-			}
-		});
-		handlerThread.start();
-	}
-
-	/**
-	 * Error condition occurs. Record error and close connection
-	 * 
-	 * @param e
-	 */
-	protected synchronized void setError(Throwable e) {
-		if (error == null) {
-			// maybe log instead?
-			e.printStackTrace();
-			error = e;
-			close();
-		}
 	}
 
@@ -94,11 +53,7 @@
 		if (handler == null) {
 			throw new IllegalStateException(
-					"BasicConnection has not been initialized or was closed");
+					"BasicConnection has not been initialized");
 		}
-		try {
-			messages.put(new Data<OUT>(data));
-		} catch (InterruptedException e) {
-			setError(e);
-		}
+		handler.notifyChange(data);
 	}
 
@@ -115,82 +70,11 @@
 	@Override
 	public void close() {
-		System.out.println("flushing and terminating " + this);
-		if (handler == null || messages.contains(EOS))
-			return;
-		try {
-			messages.put(EOS);
-		} catch (InterruptedException e) {
-			setError(e);
-		}
+
 	}
 
 	@Override
-	public String toString() {
-		return "BasicConnection[" + reference + "]";
-	}
-
-	@Override
-	public Throwable getError() {
-		return error;
-	}
-
-	/**
-	 * 
-	 * @return true iff this connection is open. Returns false also when then
-	 *         handler is in the close-down process
-	 */
-	public boolean isOpen() {
-		return handler != null && !messages.contains(EOS);
-	}
-
-	/****************** implements listenable ****************/
-	// override because notifyListeners should throw exceptions.
-	@Override
-	public void addListener(Listener<IN> l) {
-		listeners.add(l);
-	}
-
-	@Override
-	public void removeListener(Listener<IN> l) {
-		listeners.remove(l);
-	}
-
-	public void notifyListeners(IN data) {
-		for (Listener<IN> l : listeners) {
-			l.notifyChange(data);
-		}
+	public Error getError() {
+		return null;
 	}
 
 }
-
-/**
- * Wrapper around data so that we can put Null end EOS in a
- * {@link ArrayBlockingQueue}
- *
- * @param <S> the type of contained data.
- */
-
-interface Info<S> {
-
-}
-
-class Data<S> implements Info<S> {
-	private final S data;
-
-	public Data(S data) {
-		this.data = data;
-	}
-
-	public S get() {
-		return data;
-	}
-}
-
-/**
- * End of stream.
- * 
- * @author wouter
- *
- */
-class EOS<S> implements Info<S> {
-}
Index: /simplerunner/src/main/java/geniusweb/simplerunner/ClassPathConnectionFactory.java
===================================================================
--- /simplerunner/src/main/java/geniusweb/simplerunner/ClassPathConnectionFactory.java	(revision 53)
+++ /simplerunner/src/main/java/geniusweb/simplerunner/ClassPathConnectionFactory.java	(revision 1)
@@ -11,8 +11,8 @@
 import geniusweb.actions.Action;
 import geniusweb.actions.PartyId;
-import geniusweb.inform.Inform;
 import geniusweb.party.Party;
-import geniusweb.protocol.partyconnection.ProtocolToPartyConn;
-import geniusweb.protocol.partyconnection.ProtocolToPartyConnFactory;
+import geniusweb.party.inform.Inform;
+import geniusweb.protocol.partyconnection.ConnectionWithParty;
+import geniusweb.protocol.partyconnection.ConnectionWithPartyFactory;
 import geniusweb.references.Reference;
 import tudelft.utilities.repository.NoResourcesNowException;
@@ -22,147 +22,38 @@
  * <code>classpath:org/my/package/class</code>
  * 
+ * 
+ *
  */
-public class ClassPathConnectionFactory implements ProtocolToPartyConnFactory {
-	private List<ConnectionPair> allConnections = new LinkedList<>();
-
-	/**
-	 * @param reference the party class path reference4
-	 */
-	@Override
-	public ProtocolToPartyConn connect(Reference reference) {
-		ConnectionPair connpair = new ConnectionPair(reference);
-		allConnections.add(connpair);
-		return connpair.getProtocolToPartyConn();
-	}
+public class ClassPathConnectionFactory implements ConnectionWithPartyFactory {
+	private static final String SCHEME = "classpath";
+	private static int serialcounter = 1;
+	private final static URI PROTOCOLURI = uri("protocol:protocol");
 
 	@Override
-	public List<ProtocolToPartyConn> connect(List<Reference> references)
-			throws IOException, NoResourcesNowException {
-		List<ProtocolToPartyConn> connections = new LinkedList<>();
-		for (Reference partyref : references) {
-			connections.add(connect(partyref));
-		}
-		return connections;
-	}
-
-	/**
-	 * @return list of connections that are still open.
-	 */
-	public List<BasicConnection> getOpenConnections() {
-		List<BasicConnection> open = new LinkedList<>();
-		for (ConnectionPair connpair : allConnections) {
-			open.addAll(connpair.getOpenConnections());
-		}
-		return open;
-	}
-
-}
-
-class BasicConnectionWithParty extends BasicConnection<Action, Inform>
-		implements ProtocolToPartyConn {
-
-	private PartyId id;
-
-	public BasicConnectionWithParty(Reference reference, URI uri) {
-		super(reference, uri);
-		this.id = new PartyId(uri.toString().replace("classpath:", "")
-				.replaceAll("\\.", "_"));
-	}
-
-	@Override
-	public PartyId getParty() {
-		return id;
-	}
-
-	@Override
-	public String toString() {
-		return "WP" + super.toString();
-	}
-
-}
-
-/**
- * Contains the connection from protocol to party and from party to protocol.
- * These two are dependent on each other, and must close together.
- *
- */
-class ConnectionPair {
-	private static int serialcounter = 1;
-	private static final String SCHEME = "classpath";
-	private final static URI PROTOCOLURI = uri("protocol:protocol");
-
-	private final BasicConnection<Inform, Action> party2protocol;
-	private final BasicConnectionWithParty protocol2party;
-
-	/**
-	 * 
-	 * @param reference the party class path reference4
-	 * 
-	 */
-	public ConnectionPair(Reference reference) {
+	public ConnectionWithParty connect(Reference reference) {
 		// set up the whole other party including the connection to it.
 		String classpath = getClassPath(reference.getURI());
 		Party party = instantiate(classpath);
 
-		// if call to protocol would fail, we should also close the
-		// protocol2party connection. But we assume that will work fine.
-		party2protocol = new BasicConnection<Inform, Action>(reference,
-				PROTOCOLURI) {
-
-			@Override
-			public void close() {
-				if (isOpen()) {
-					super.close();
-					protocol2party.close();
-				}
-			}
-
-		};
-
-		// if callback from protocol to party fails, then also close the
-		// other direction.
-		protocol2party = new BasicConnectionWithParty(reference,
+		BasicConnection<Inform, Action> party2protocol = new BasicConnection<Inform, Action>(
+				reference, PROTOCOLURI);
+		BasicConnectionWithParty protocol2party = new BasicConnectionWithParty(
+				reference,
 				uri("classpath:" + reference.getURI().getSchemeSpecificPart()
-						+ "." + (serialcounter++))) {
-			@Override
-			public void close() {
-				if (isOpen()) {
-					super.close();
-					party2protocol.close();
-				}
-			}
-
-		};
-
-		party2protocol.init(action -> protocol2party.notifyListeners(action));
-
-		protocol2party.init(info -> party2protocol.notifyListeners(info));
+						+ "." + (serialcounter++)));
+		party2protocol.init(action -> protocol2party.notifyChange(action));
+		protocol2party.init(info -> party2protocol.notifyChange(info));
 
 		party.connect(party2protocol);
 
-	}
-
-	/**
-	 * 
-	 * @return the open connections
-	 */
-	public List<BasicConnection> getOpenConnections() {
-		List<BasicConnection> open = new LinkedList<>();
-		if (party2protocol.isOpen())
-			open.add(party2protocol);
-		if (protocol2party.isOpen())
-			open.add(protocol2party);
-		return open;
-	}
-
-	public BasicConnectionWithParty getProtocolToPartyConn() {
 		return protocol2party;
 	}
 
-	/**
-	 * Internal use for testing
-	 */
-	protected BasicConnection getPartyToProtocolConn() {
-		return party2protocol;
+	private static URI uri(String ref) {
+		try {
+			return new URI(ref);
+		} catch (URISyntaxException e) {
+			throw new IllegalStateException("failed to create basic URI", e);
+		}
 	}
 
@@ -192,15 +83,7 @@
 				| InvocationTargetException e) {
 			throw new IllegalArgumentException(
-					"Failed to create connection to party " + classpath, e);
+					"Failed to create party connection", e);
 		}
 
-	}
-
-	private static URI uri(String ref) {
-		try {
-			return new URI(ref);
-		} catch (URISyntaxException e) {
-			throw new IllegalStateException("failed to create basic URI", e);
-		}
 	}
 
@@ -218,3 +101,31 @@
 	}
 
+	@Override
+	public List<ConnectionWithParty> connect(List<Reference> references)
+			throws IOException, NoResourcesNowException {
+		List<ConnectionWithParty> connections = new LinkedList<>();
+		for (Reference partyref : references) {
+			connections.add(connect(partyref));
+		}
+		return connections;
+	}
+
 }
+
+class BasicConnectionWithParty extends BasicConnection<Action, Inform>
+		implements ConnectionWithParty {
+
+	private PartyId id;
+
+	public BasicConnectionWithParty(Reference reference, URI uri) {
+		super(reference, uri);
+		this.id = new PartyId(uri.toString().replace("classpath:", "")
+				.replaceAll("\\.", "_"));
+	}
+
+	@Override
+	public PartyId getParty() {
+		return id;
+	}
+
+}
Index: /simplerunner/src/main/java/geniusweb/simplerunner/NegoRunner.java
===================================================================
--- /simplerunner/src/main/java/geniusweb/simplerunner/NegoRunner.java	(revision 53)
+++ /simplerunner/src/main/java/geniusweb/simplerunner/NegoRunner.java	(revision 1)
@@ -9,6 +9,11 @@
 import com.fasterxml.jackson.databind.ObjectMapper;
 
+import geniusweb.events.ProtocolEvent;
+import geniusweb.protocol.CurrentNegoState;
+import geniusweb.protocol.NegoProtocol;
 import geniusweb.protocol.NegoSettings;
-import geniusweb.simplerunner.gui.GUI;
+import geniusweb.protocol.partyconnection.ConnectionWithPartyFactory;
+import geniusweb.protocol.session.SessionSettings;
+import tudelft.utilities.logging.ReportToLogger;
 import tudelft.utilities.logging.Reporter;
 
@@ -17,32 +22,48 @@
  * All referred files and classes need to be stored locally (or be in the
  * dependency list if you use maven).
- * <p>
- * <em>IMPORTANT</em> SimpleRunner has a number of restrictions, compared to a
- * run using a runserver and partyserver
- * <ul>
- * <li>With stand-alone runner, your parties are run together in a single
- * classloader. The main implication is that there may arise version conflicts
- * between parties.
- * <li>Stand-alone runner does NOT enforce the time deadline. Parties may
- * continue running indefinitely and thus bog down the JVM and stalling
- * tournaments.
- * </ul>
+ * 
  */
-public class NegoRunner {
+public class NegoRunner implements Runnable {
+	private final NegoSettings settings;
+	private final NegoProtocol protocol;
+	private final ConnectionWithPartyFactory connectionfactory;
+	private final Reporter log;
 	private final static ObjectMapper jackson = new ObjectMapper();
 
-	/**
-	 * The main runner
-	 * 
-	 * @param args should have 0 or 1 argument. If 0 arguments, the {@link GUI}
-	 *             is started. If one argoment, it should be a filename
-	 *             containing a settings.json file. That session is then run.
-	 * @throws IOException if problem occurs
-	 */
+	public NegoRunner(NegoSettings settings,
+			ConnectionWithPartyFactory connectionfactory, Reporter logger) {
+		if (settings == null || connectionfactory == null) {
+			throw new NullPointerException("Arguments must be not null");
+		}
+		this.settings = settings;
+		this.log = logger;
+		this.protocol = settings.getProtocol(log);
+		this.connectionfactory = connectionfactory;
+	}
+
+	@Override
+	public void run() {
+		protocol.addListener(evt -> handle(evt));
+		protocol.start(connectionfactory);
+	}
+
+	private void handle(ProtocolEvent evt) {
+		if (evt instanceof CurrentNegoState && ((CurrentNegoState) evt)
+				.getState().isFinal(System.currentTimeMillis())) {
+			stop();
+		}
+	}
+
+	protected void stop() {
+		if (protocol.getState().getError() != null) {
+			log.log(Level.WARNING, "protocol terminated abnormally",
+					protocol.getState().getError());
+		} else {
+			log.log(Level.INFO,
+					"protocol ended normally: " + protocol.getState());
+		}
+	}
+
 	public static void main(String[] args) throws IOException {
-		if (args.length == 0) {
-			GUI.main(args);
-			return;
-		}
 		if (args.length != 1) {
 			showusage();
@@ -51,14 +72,15 @@
 		String serialized = new String(Files.readAllBytes(Paths.get(args[0])),
 				StandardCharsets.UTF_8);
-		NegoSettings settings = jackson.readValue(serialized,
-				NegoSettings.class);
+		SessionSettings settings = jackson.readValue(serialized,
+				SessionSettings.class);
 
-		Runner runner = new Runner(settings, new ClassPathConnectionFactory(),
-				new StdOutReporter(), 0);
+		NegoRunner runner = new NegoRunner(settings,
+				new ClassPathConnectionFactory(),
+				new ReportToLogger("sessionrunner"));
 		runner.run();
 	}
 
 	private static void showusage() {
-		System.err.println("GeniusWeb stand-alone runner.");
+		System.err.println("GeniusWeb stand-alone runner. ");
 		System.err.println("first argument should be <settings.json>.");
 		System.err.println(
@@ -68,20 +90,3 @@
 
 	}
-
 }
-
-class StdOutReporter implements Reporter {
-	@Override
-	public void log(Level level, String msg) {
-		if (level == Level.WARNING || level == Level.SEVERE)
-			System.err.println(level + ":" + msg);
-		else
-			System.out.println(level + ":" + msg);
-	}
-
-	@Override
-	public void log(Level arg0, String msg, Throwable arg2) {
-		log(arg0, msg);
-	}
-
-}
Index: /simplerunner/src/test/java/geniusweb/simplerunner/ClassPathConnectionFactoryTest.java
===================================================================
--- /simplerunner/src/test/java/geniusweb/simplerunner/ClassPathConnectionFactoryTest.java	(revision 53)
+++ /simplerunner/src/test/java/geniusweb/simplerunner/ClassPathConnectionFactoryTest.java	(revision 1)
@@ -1,5 +1,4 @@
 package geniusweb.simplerunner;
 
-import static org.junit.Assert.assertEquals;
 import static org.junit.Assert.assertNotNull;
 
@@ -11,17 +10,15 @@
 
 import geniusweb.actions.Action;
-import geniusweb.connection.ConnectionEnd;
-import geniusweb.inform.Inform;
+import geniusweb.connection.Connection;
+import geniusweb.party.inform.Inform;
 import geniusweb.references.PartyRef;
+import geniusweb.simplerunner.ClassPathConnectionFactory;
 
 public class ClassPathConnectionFactoryTest {
 	private ClassPathConnectionFactory factory;
-	private PartyRef PARTYREF;
 
 	@Before
-	public void before() throws URISyntaxException {
+	public void before() {
 		factory = new ClassPathConnectionFactory();
-		PARTYREF = new PartyRef(
-				"classpath:geniusweb.exampleparties.randomparty.RandomParty");
 
 	}
@@ -45,51 +42,8 @@
 	@Test
 	public void testRandomParty() throws IOException, URISyntaxException {
-		ConnectionEnd<Action, Inform> party = factory.connect(PARTYREF);
+		Connection<Action, Inform> party = factory.connect(new PartyRef(
+				"classpath:geniusweb.exampleparties.randomparty.RandomParty"));
 		assertNotNull(party);
 	}
 
-	@Test
-	public void testConnectionPairProtocolClosesNormally()
-			throws InterruptedException {
-		ConnectionPair cpair = new ConnectionPair(PARTYREF);
-		assertEquals(2, cpair.getOpenConnections().size());
-		cpair.getProtocolToPartyConn().close();
-		Thread.sleep(100);
-
-		assertEquals(0, cpair.getOpenConnections().size());
-
-	}
-
-	@Test
-	public void testConnectionPairProtocolClosesWithExc()
-			throws InterruptedException {
-		ConnectionPair cpair = new ConnectionPair(PARTYREF);
-		assertEquals(2, cpair.getOpenConnections().size());
-		cpair.getProtocolToPartyConn().setError(new Error("test"));
-		Thread.sleep(100);
-		assertEquals(0, cpair.getOpenConnections().size());
-	}
-
-	@Test
-	public void testConnectionPairPartyClosesNormally()
-			throws InterruptedException {
-		ConnectionPair cpair = new ConnectionPair(PARTYREF);
-		assertEquals(2, cpair.getOpenConnections().size());
-		cpair.getPartyToProtocolConn().close();
-		Thread.sleep(100);
-
-		assertEquals(0, cpair.getOpenConnections().size());
-
-	}
-
-	@Test
-	public void testConnectionPairPartyClosesWithExc()
-			throws InterruptedException {
-		ConnectionPair cpair = new ConnectionPair(PARTYREF);
-		assertEquals(2, cpair.getOpenConnections().size());
-		cpair.getPartyToProtocolConn().setError(new Error("test"));
-		Thread.sleep(100);
-		assertEquals(0, cpair.getOpenConnections().size());
-	}
-
 }
